<?php

namespace App\Controllers\Front;

use App\Models\ProductModel;
use CodeIgniter\HTTP\RequestInterface;
use CodeIgniter\HTTP\ResponseInterface;
use Psr\Log\LoggerInterface;

class ProductController extends FrontController
{
    public function initController(RequestInterface $request, ResponseInterface $response, LoggerInterface $logger)
    {
        $this->_model = new ProductModel();
        parent::initController($request, $response, $logger);
        $this->_viewDatas['title'] = lang($this->_model->getClassName() . '.title');
        $this->_viewPath .= strtolower($this->_model->getClassName());
        helper($this->_model->getClassName());
    }

    public function getFields(string $action = ""): array
    {
        $fields = ["category_uid", 'name', "photo", "cost", "price", "sale", "stock", "view_cnt", "status", "content",];
        switch ($action) {
            case "index":
            case "excel":
                return ["category_uid", "user_uid", 'name', "photo", "cost", "price", "sale", "stock", "view_cnt", "status", "created_at"];
                break;
            case "view":
                return [...$fields, "created_at"];
                break;
            default:
                return $fields;
                break;
        }
    }
    public function getFieldFilters(): array
    {
        return ["category_uid", "user_uid", "status"];
    }
    public function getFieldBatchFilters(): array
    {
        return parent::getFieldBatchFilters();
    }
    //Field별 Form Datas 처리용
    protected function getFieldFormData(string $field, $entity = null): array
    {
        switch ($field) {
            case 'photo':
                $this->_viewDatas['fieldDatas'][$field] = $this->single_upload_procedure($field, $entity);
                break;
            default:
                return parent::getFieldFormData($field, $entity);
                break;
        }
        return $this->_viewDatas['fieldDatas'];
    }
}
